#include "cairo-box.h"

enum
{
    NO_PROP,
    BOX_MODE,
    N_PROPERTIES
};
static GParamSpec *g_prop[N_PROPERTIES] = {0};

struct _DiyaCairoBox
{
    DiyaCairoContainer parent_object;
    guint mode;
};

G_DEFINE_FINAL_TYPE(DiyaCairoBox, diya_cairo_box, DIYA_TYPE_CAIRO_CONTAINER)

static void diya_cairo_box_dispose(GObject * object)
{
    g_debug("diya_cairo_box_dispose: %s", diya_object_to_string(object));
    G_OBJECT_CLASS(diya_cairo_box_parent_class)->dispose(object);
}

static void diya_cairo_box_init(DiyaCairoBox* self)
{
    self->mode = DIYA_CAIRO_HORIZONTAL_BOX;
}

static void diya_cairo_box_set_property(GObject *object, guint property_id, const GValue *value, GParamSpec *pspec)
{
    DiyaCairoBox * self = DIYA_CAIRO_BOX(object);
    switch (property_id)
    {
    case BOX_MODE:
        self->mode = g_value_get_uint(value);
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
        break;
    }
}

static void diya_cairo_box_get_property(GObject *object, guint property_id, GValue *value, GParamSpec *pspec)
{
    DiyaCairoBox * self = DIYA_CAIRO_BOX(object);
    switch (property_id)
    {
    case BOX_MODE:
        g_value_set_uint(value, self->mode);
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
        break;
    }
}

static void diya_cairo_box_class_init(DiyaCairoBoxClass * class)
{
    GObjectClass *gobject_class = G_OBJECT_CLASS(class);
    DIYA_CAIRO_WIDGET_SET_NAME(class, "DiyaCairoBox");
    gobject_class->dispose = diya_cairo_box_dispose;
    gobject_class->set_property = diya_cairo_box_set_property;
    gobject_class->get_property = diya_cairo_box_get_property;
    g_prop[BOX_MODE] = g_param_spec_pointer("mode", NULL, "Box mode", G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY);
    g_object_class_install_properties (gobject_class, N_PROPERTIES, g_prop);
}